application/controllers/AssessmentController.php
<?php

class AssessmentController extends LSBaseController
{
    /**
     * It's import to have the accessRules set (security issue).
     * Only logged in users should have access to actions. All other permissions
     * should be checked in the action itself.
     *
     * @return array
     */
    public function accessRules()
    {
        return [
            [
                'allow',
                'actions' => [],
                'users'   => ['*'], //everybody
            ],
            [
                'allow',
                'actions' => ['activate', 'delete', 'edit', 'index', 'insertUpdate'],
                'users'   => ['@'], //only login users
            ],
            ['deny'], //always deny all actions not mentioned above
        ];
    }


    /**
     * This part comes from renderWrappedTemplate
     *
     * @param string $view View
     *
     * @return bool
     */
    protected function beforeRender($view)
    {
        if (isset($this->aData['surveyid'])) {
            $this->aData['oSurvey'] = $this->aData['oSurvey'] ?? Survey::model()->findByPk($this->aData['surveyid']);
            $this->layout = 'layout_questioneditor';
        }

        return parent::beforeRender($view);
    }

    /**
     * Renders th view for: show the list of assessments(if assessment is activated)
     *                      or the button to activate assessment mode
     *
     * @param int $surveyid the survey id
     *
     */
    public function actionIndex($surveyid)
    {
        $iSurveyID = sanitize_int($surveyid);
        if (!Permission::model()->hasSurveyPermission($iSurveyID, 'assessments', 'read')) {
            Yii::app()->setFlashMessage(gT("You do not have permission to access this page."), 'error');
            $this->redirect(array("admin/"));
        }

        $oSurvey =     Survey::model()->findByPk($iSurveyID);

        $this->setLanguagesBeforeAction($oSurvey);

        $aData = [];
        $aData['survey'] = $oSurvey;
        $aData['surveyid'] = $iSurveyID;

        Yii::app()->loadHelper('admin.htmleditor');

        $this->prepareDataArray($aData);

        //this part is from _renderWrapptemplate in old controller
        $aData['sidemenu']['state'] = false;
        $aData['title_bar']['title'] = $oSurvey->currentLanguageSettings->surveyls_title . " (" . gT("ID") . ":" . $iSurveyID . ")";
        $aData['gid'] = null; //important for rendering the sidebar ...(why?)
        Yii::app()->getClientScript()->registerScript(
            "AssessmentsVariables",
            "var strnogroup = '" . gT("There are no groups available.", "js") . "';",
            LSYii_ClientScript::POS_BEGIN
        );
        App()->getClientScript()->registerScriptFile(App()->getConfig('adminscripts') . 'assessments.js', LSYii_ClientScript::POS_BEGIN);

        PrepareEditorScript(true, $this);
        $this->aData = $aData;
        $this->render('assessments_view', $this->aData);
    }

    /**
     * Activates assessment mode for the survey.
     *
     * @param $surveyid
     */
    public function actionActivate($surveyid)
    {

        $iSurveyID = sanitize_int($surveyid);
        if (!Permission::model()->hasSurveyPermission($iSurveyID, 'assessments', 'create')) {
            Yii::app()->setFlashMessage(gT("You do not have permission to activate assessment."), 'error');
            $this->redirect(array("admin/"));
        }
        $oSurvey = Survey::model()->findByPk($iSurveyID);
        $oSurvey->assessments = "Y"; //activate assessment

        if (!$oSurvey->save()) {
            Yii::app()->setFlashMessage(gT("Assessment could not be activated."), 'error');
        }

        $this->redirect($this->createUrl('/assessment/index', ['surveyid' => $surveyid]));
    }

    /**
     * Save btn of modal view. This could be update or insert.
     * Redirects to the correct action
     *
     * @param int $surveyid
     *
     */
    public function actionInsertUpdate($surveyid)
    {
        //the post param 'action' could have the values 'assessmentupdate' or 'assessmentadd'
        $actionInserUpdate = App()->request->getPost('action', 'assessmentadd');
        if ($actionInserUpdate === 'assessmentadd') {
            $this->add($surveyid);
        }
        if ($actionInserUpdate === 'assessmentupdate') {
            $this->update($surveyid);
        }

        //this should not happen, unknown action
        Yii::app()->setFlashMessage(gT("Unknown action for assessment."), 'error');
        $this->redirect($this->createUrl('/assessment/index', ['surveyid' => $surveyid]));
    }

    /**
     * Deletes an assessment.
     *
     * @param int $surveyid
     * @return void
     */
    public function actionDelete($surveyid)
    {
        $iSurveyID = sanitize_int($surveyid);
        if (Permission::model()->hasSurveyPermission($iSurveyID, 'assessments', 'delete')) {
            //must be deleteAll because of languages...
            $assessmentId = (int) App()->request->getPost('id');
            Assessment::model()->deleteAllByAttributes(array('id' => $assessmentId, 'sid' => $iSurveyID));
        } else {
            Yii::app()->setFlashMessage(gT("You have no permission to delete assessments"), 'error');
        }
    }

    /**
     * Insert the assessment with multilanguages
     *
     * @param $surveyid
     */
    private function add($surveyid)
    {
        $iSurveyID = sanitize_int($surveyid);
        $oSurvey = Survey::model()->findByPk($iSurveyID);
        if (Permission::model()->hasSurveyPermission($iSurveyID, 'assessments', 'create')) {
            $bFirst = true;
            $iAssessmentID = -1;
            $languages = $oSurvey->additionalLanguages;
            $surveyLanguage = $oSurvey->language;
            array_unshift($languages, $surveyLanguage);
            foreach ($languages as $sLanguage) {
                $aData = $this->getAssessmentPostData($iSurveyID, $sLanguage);
                if ($bFirst === false) {
                    $aData['id'] = $iAssessmentID;
                }
                $assessment = Assessment::model()->insertRecords($aData);

                if ($bFirst === true) {
                    $bFirst = false;
                    $iAssessmentID = $assessment->id;
                }
            }
        }
        $this->redirect($this->createUrl('/assessment/index', ['surveyid' => $surveyid]));
    }

    /**
     * Updates an assessment. Receives input from POST
     *
     * @param int $iSurveyID
     * @return void
     */
    private function update($iSurveyID)
    {
        $iSurveyID = sanitize_int($iSurveyID);
        if (Permission::model()->hasSurveyPermission($iSurveyID, 'assessments', 'update') && App()->request->getPost('id', null) != null) {
            $aid = App()->request->getPost('id', null);
            $oSurvey = Survey::model()->findByPk($iSurveyID);
            $languages = $oSurvey->additionalLanguages;
            $surveyLanguage = $oSurvey->language;
            array_unshift($languages, $surveyLanguage);
            foreach ($languages as $language) {
                $aData = $this->getAssessmentPostData($iSurveyID, $language);
                Assessment::model()->updateAssessment($aid, $iSurveyID, $language, $aData);
            }
            $this->redirect($this->createUrl('/assessment/index', ['surveyid' => $iSurveyID]));
        }
    }

    /**
     * Feed JSON to modal.
     *
     * Gets the data for the assessment from db and gives it back to the modal view to show the values.
     *
     * @param int $surveyid
     * @return void
     */
    public function actionEdit($surveyid)
    {
        $iAsessementId = App()->request->getParam('id');
        $oAssessments = Assessment::model()->findAll("id=:id", [':id' => $iAsessementId]);
        if ($oAssessments !== null && Permission::model()->hasSurveyPermission($surveyid, 'assessments', 'update')) {
            $aData = [];
            $aData['editData'] = $oAssessments[0]->attributes;
            foreach ($oAssessments as $oAssessment) {
                $aData['models'][] = $oAssessment;
                $aData['editData']['name_' . $oAssessment->language] = $oAssessment->name;
                $aData['editData']['assessmentmessage_' . $oAssessment->language] = $oAssessment->message;
            }
            $action = 'assessmentedit';
            $aData['action'] = $action;

            $this->renderPartial('/admin/super/_renderJson', ['data' => $aData]);
        }
    }


    /**     *******************************  FOLLOWING FUNCTIONS ARE NO ACTIONS                *********************  */

    /**
     * @param array $aData
     * @param boolean $collectEdit
     * @return array
     */
    private function prepareDataArray(&$aData, $collectEdit = false)
    {
        $iSurveyID = $aData['surveyid'];
        $oSurvey = $aData['survey'];

        $aHeadings = array(gT("Scope"), gT("Question group"), gT("Minimum"), gT("Maximum"));
        $aData['headings'] = $aHeadings;
        $oAssessments = Assessment::model();
        $oAssessments->sid = $iSurveyID;

        $aData['groups'] = $this->collectGroupData($oSurvey, $aData);
        $this->setSearchParams($oAssessments);
        $aData['model'] = $oAssessments;
        if (isset($_POST['pageSize'])) {
            Yii::app()->user->setState('pageSize', Yii::app()->request->getParam('pageSize'));
        }
        $aData['actiontitle'] = gT("Add");
        $aData['actionvalue'] = "assessmentadd";
        $aData['editId'] = '';

        if ($collectEdit === true) {
            $aData = $this->collectEditData($aData);
        }

        $aData['imageurl'] = Yii::app()->getConfig('adminimageurl');
        $aData['assessments'] = $oAssessments;
        $aData['assessmentlangs'] = Yii::app()->getConfig("assessmentlangs");
        $aData['baselang'] = $oSurvey->language;
        $aData['subaction'] = gT("Assessments");
        $aData['groupId'] = App()->request->getPost('gid', '');
        return $aData;
    }

    /**

application/views/assessment/assessments_delete.php
<?php
/*
 * Assessments delete
 */
?>
<div id="assesements-delete" class="modal fade" role="dialog">
    <div class="modal-dialog">
        <div class="modal-content">
            <?php echo CHtml::form(array("assessment/delete/surveyid/$surveyid"), 'post', array('class'=>'form','id'=>'assessmentsdeleteform','name'=>'assessmentsdeleteform', 'role' => 'form'));?>
            <?php
            Yii::app()->getController()->renderPartial(
                '/layouts/partial_modals/modal_header',
                ['modalTitle' => gt('Delete assessment rule')]
            );
            ?>
                <div class="modal-body">
                    <!-- delete params -->
                    <div>
                        <input type='hidden' name='sid' value='<?php echo $surveyid;?>' />
                        <input type='hidden' name='id' value='' />
                    </div>
                    <p class='modal-body-text'><?php eT("Do you really want to delete this asessment rule?"); ?></p>
                </div>
                <div class="modal-footer modal-footer-buttons">
                    <button type="button" class="btn btn-cancel" data-dismiss="modal"><?php eT('Cancel'); ?></button>
                    <button type="button" class="btn btn-danger" id="selector__assessements-delete-modal" ><?php eT("Delete")?></button>
                </div>
            </form>
        </div>
    </div>
</div>

application/views/assessment/assessments_edit.php
<?php
/*
* Assessments edit
*/
?>
  <div id="assesements-edit-add" class="modal fade" role="dialog">
    <div class="modal-dialog">
      <div class="modal-content">
        <?php echo CHtml::form(array("/assessment/insertUpdate/surveyid/$surveyid"), 'post', array('class'=>'form','id'=>'assessmentsform','name'=>'assessmentsform', 'role' => 'form'));?>
          <?php
          Yii::app()->getController()->renderPartial(
              '/layouts/partial_modals/modal_header',
              ['modalTitle' => gt('Add assessment rule')]
          );
          ?>
          <div class="modal-body">
            <!-- Scope, Total, Group -->
            <div class='row'>
              <div class='form-group col-md-12'>
                <label class='control-label col-sm-2'>
                  <?php eT("Scope:");?>
                </label>
                <div class='col-sm-10 ls-flex wrap'>
                  <div class='col-md-4 col-sm-5 col-xs-6'>
                    <label class='radio-inline'>
                      <input class='' type='radio' id='radiototal' name='scope' value='T' checked='checked' />
                      <?php eT("Total"); ?>
                    </label>
                  </div>

                  <div class='col-md-4 col-sm-5 col-xs-6'>
                    <label class='radio-inline'>
                      <input class='' type='radio' id='radiogroup' name='scope' value='G' />
                      <?php eT("Group"); ?>
                    </label>
                  </div>
                </div>
              </div>
              <!-- Question group -->
              <div class='form-group col-md-12'>
                <label class='control-label col-sm-2' for='gid'>
                  <?php eT("Question group:");?>
                </label>
                <div class='col-sm-10'>
                  <?php if (isset($groups)) { ?>
                    <select name='gid' id='gid' class="form-control">
                        <?php foreach ($groups as $groupId => $groupName) { ?>
                        <option value="<?=$groupId?>" ><?=flattenText($groupName)?></option>
                        <?php } ?>
                    </select>
                    <?php } else { echo eT("No question group found."); } ?>
                </div>
                <div class='col-sm-2 hide-xs'></div>
              </div>

            </div>
            <div class='row'>
              <!-- Minimum -->
              <div class='form-group col-md-12'>
                <label class='control-label col-sm-2' for='minimum'>
                  <?php eT("Minimum:");?>
                </label>
                <div class='col-sm-10'>
                  <input class='form-control numbersonly' type='text' id='minimum' name='minimum' />
                </div>
                <div class='col-sm-2 hide-xs'></div>
              </div>

              <!-- Maximum -->
              <div class='form-group col-md-12'>
                <label class='control-label col-sm-2' for='maximum'>
                  <?php eT("Maximum:");?>
                </label>
                <div class='col-sm-10'>
                  <input class='form-control numbersonly' type='text' id='maximum' name='maximum' />
                </div>
                <div class='col-sm-2 hide-xs'></div>
              </div>
            </div>

            <!-- Languages tabs -->
            <div id="languagetabs" class="row">
              <ul class="nav nav-tabs" id="edit-survey-text-element-language-selection">
                <?php foreach ($assessmentlangs as $assessmentlang) {
                $position=0;
                ?>
                <li role="presentation" class="<?=($assessmentlang==$baselang ? 'active' : '')?>">
                    <a data-toggle="tab"  href="#tablang<?=$assessmentlang?>">
                        <?php 
                        echo getLanguageNameFromCode($assessmentlang, false);
                            if ($assessmentlang==$baselang) {
                                echo ' ('.gT("Base language").')';
                            }
                        ?>
                    </a>
                </li>
                <?php } ?>
              </ul>

              <div class="tab-content">
                <?php
                    $count = 0;
                    foreach ($assessmentlangs as $assessmentlang) {
                        $heading=''; $message='';
                ?>
                  <div id="tablang<?=$assessmentlang;?>" class="tab-pane fade in <?php if($count==0){ echo " active "; $count++;}?>">
                    <div class='col-sm-12'></div>
                    <div class='form-group col-sm-12'>
                      <label class='control-label col-sm-12' for='name_<?=$assessmentlang?>'>
                        <?php eT("Heading");?>:</label>
                      <div class='col-sm-12'>
                        <input class='form-control' type='text' name='name_<?=$assessmentlang?>' id='name_<?=$assessmentlang?>>' size='80' value='<?=$heading?>' />
                      </div>
                    </div>
                    <div class='form-group col-sm-12'>
                      <label class='control-label col-sm-12' for='assessmentmessage_<?=$assessmentlang?>'>
                        <?php eT("Message");?>:</label>
                      <div class='col-sm-12'>
                        <div class="htmleditor input-group">
                          <textarea name='assessmentmessage_<?=$assessmentlang?>' class="form-control" id='assessmentmessage_<?=$assessmentlang?>' rows='10' ><?php echo $message;?></textarea>
                          <?php echo getEditor("assessment-text","assessmentmessage_".$assessmentlang, "[".gT("Message:", "js")."]",$surveyid,$gid,null,''); ?>
                        </div>
                      </div>
                    </div>
                    <div class='form-group'>
                      <div class='col-sm-2'></div>
                      <div class='col-sm-4'>
                        <input type='submit' class="btn btn-default hidden" value='<?php eT("Save");?>' />
                      </div>
                    </div>
                  </div>
                  <?php } ?>
              </div>
            </div>

            <!-- action buttons -->
            <div>
              <input type='hidden' name='sid' value='<?php echo $surveyid;?>' />
              <input type='hidden' name='action' value='assessmentadd' />
              <input type='hidden' name='id' value='<?php echo $editId;?>' />
            </div>
          </div>
          <div class="modal-footer">
            <button type="button" class="btn btn-cancel" data-dismiss="modal"><?php eT("Cancel");?></button>
            <button type="button" class="btn btn-success" id="selector__assessments-save-modal"><?php eT('Add'); ?></button>
          </div>
          </form>
      </div>
    </div>
  </div>

application/views/assessment/assessments_view.php
<?php
/**
* Assesments view
*/

// todo implement new ekeditor 1580136051118
//echo PrepareEditorScript(true, $this);

$pageSize = intval(Yii::app()->user->getState('pageSize', Yii::app()->params['defaultPageSize']));

?>
  <div class="side-body <?=getSideBodyClass(false)?>">
    <?=viewHelper::getViewTestTag('surveyAssessments');?>
      <h3 class="page-title"><?=gT("Assessments")?></h3>
        <?php
            $messageLink = gT("Assessment mode for this survey is not activated.").'<br/>'
                . gT("If you want to activate it, click here:").'<br/>'
                . '<a type="submit" class="btn btn-primary" href="'
                . $this->createUrl('/assessment/activate', ['surveyid'=> $surveyid])
                .'">'.gT('Activate assessements').'</a>';
        if(!Assessment::isAssessmentActive($surveyid)) {
        ?>
          <div class="row text-center">
            <div class="jumbotron message-box warningheader col-sm-12 col-md-6 col-md-offset-3">
              <h2><?= gT("Assessment mode not activated"); ?></h2>
              <?php echo $messageLink; ?>
            </div>
          </div>

        <?php
        } else {
        ?>
            <h4><?php eT("Assessment rules");?></h4>
            <div class="row">
                <a href="#" id="loadEditUrl_forModalView" data-editurl="<?=$this->createUrl("assessment/edit/", ["surveyid" => $surveyid]);?>"></a>
                <?php
                    $this->widget('ext.LimeGridView.LimeGridView', array(
                        'dataProvider' => $model->search(),
                        'id' => 'assessments-grid',
                        'columns' => $model->getColumns(),
                        'filter' => $model,
                        'emptyText'=>gT('No customizable entries found.'),
                        'summaryText'=>gT('Displaying {start}-{end} of {count} result(s).').' '
                        . sprintf(gT('%s rows per page'),
                            CHtml::dropDownList(
                                'pageSize',
                                $pageSize,
                                Yii::app()->params['pageSizeOptions'],
                                array('class'=>'changePageSize form-control', 'style'=>'display: inline; width: auto')
                            )
                        ),
                        'rowHtmlOptionsExpression' => '["data-assessment-id" => $data->id]',
                        'htmlOptions'              => ['class' => 'table-responsive grid-view-ls'],
                        'ajaxType'                 => 'POST',
                        'ajaxUpdate'               => 'assessments-grid',
                        'template'                 => "{items}\n<div id='tokenListPager'><div class=\"col-sm-4\" id=\"massive-action-container\"></div><div class=\"col-sm-4 pager-container ls-ba \">{pager}</div><div class=\"col-sm-4 summary-container\">{summary}</div></div>",
                        'afterAjaxUpdate'          => 'bindAction',
                    ));
                ?>
            </div>
            <?php if ( Permission::model()->hasSurveyPermission($surveyid, 'assessments', 'create') ) { ?>
              <div class="row">
                <div class="col-sm-12">
                  <button class="btn btn-success" id="selector__assessment-add-new">
                    <?=eT("Add new assessment rule")?>
                  </button>
                </div>
              </div>
            <?php } ?>
            <!-- Edition - Modal -->
            <?php if ((Permission::model()->hasSurveyPermission($surveyid, 'assessments','update'))  || (Permission::model()->hasSurveyPermission($surveyid, 'assessments','create')) ) { ?>
                <?php $this->renderPartial('assessments_delete', ['surveyid' => $surveyid]); ?>
                <?php 
                    $this->renderPartial('assessments_edit', [
                            'surveyid' => $surveyid,
                            'editId' => $editId,
                            'assessmentlangs' => $assessmentlangs,
                            'baselang' => $baselang,
                            'groups' => $groups ?? [],
                            'gid' => $groupId,
                        ]
                    );
                ?>
            <?php } ?>
  <!-- opened in controller -->
    <?php 
    };
    ?>
</div>

<script type="text/javascript">
jQuery(function($) {
    // To update rows per page via ajax
    $(document).on("change", '#pageSize', function() {
        $.fn.yiiGridView.update('assessments-grid', {data:{pageSize: $(this).val()}});
    });
});
</script>